---
title: "FreeBSD/amd64 6.0-RELEASE Release Notes"
sidenav: download
---

++++


<h3 class="CORPAUTHOR">The FreeBSD Project</h3>

<p class="COPYRIGHT">Copyright &copy; 2000, 2001, 2002, 2003, 2004, 2005 The FreeBSD
Documentation Project</p>

<p class="PUBDATE">$FreeBSD: src/release/doc/en_US.ISO8859-1/relnotes/common/new.sgml,v
1.883.2.7.2.1 2005/10/21 16:01:46 yar Exp $<br />
</p>

<div class="LEGALNOTICE"><a id="TRADEMARKS" name="TRADEMARKS"></a>
<p>FreeBSD is a registered trademark of the FreeBSD Foundation.</p>

<p>IBM, AIX, EtherJet, Netfinity, OS/2, PowerPC, PS/2, S/390, and ThinkPad are trademarks
of International Business Machines Corporation in the United States, other countries, or
both.</p>

<p>IEEE, POSIX, and 802 are registered trademarks of Institute of Electrical and
Electronics Engineers, Inc. in the United States.</p>

<p>Intel, Celeron, EtherExpress, i386, i486, Itanium, Pentium, and Xeon are trademarks or
registered trademarks of Intel Corporation or its subsidiaries in the United States and
other countries.</p>

<p>Sparc, Sparc64, SPARCEngine, and UltraSPARC are trademarks of SPARC International, Inc
in the United States and other countries. Products bearing SPARC trademarks are based
upon architecture developed by Sun Microsystems, Inc.</p>

<p>Many of the designations used by manufacturers and sellers to distinguish their
products are claimed as trademarks. Where those designations appear in this document, and
the FreeBSD Project was aware of the trademark claim, the designations have been followed
by the &#8220;&trade;&#8221; or the &#8220;&reg;&#8221; symbol.</p>
</div>

<div>
<div class="ABSTRACT"><a id="AEN23" name="AEN23"></a>
<p>The release notes for FreeBSD 6.0-RELEASE contain a summary of the changes made to the
FreeBSD base system on the 6-STABLE development line. This document lists applicable
security advisories that were issued since the last release, as well as significant
changes to the FreeBSD kernel and userland. Some brief remarks on upgrading are also
presented.</p>
</div>
</div>

<hr />
</div>

<div class="TOC">
<dl>
<dt><b>Table of Contents</b></dt>

<dt>1 <a href="#INTRO">Introduction</a></dt>

<dt>2 <a href="#NEW">What's New</a></dt>

<dd>
<dl>
<dt>2.1 <a href="#SECURITY">Security Advisories</a></dt>

<dt>2.2 <a href="#KERNEL">Kernel Changes</a></dt>

<dd>
<dl>
<dt>2.2.1 <a href="#BOOT">Boot Loader Changes</a></dt>

<dt>2.2.2 <a href="#PROC">Hardware Support</a></dt>

<dt>2.2.3 <a href="#NET-PROTO">Network Protocols</a></dt>

<dt>2.2.4 <a href="#DISKS">Disks and Storage</a></dt>

<dt>2.2.5 <a href="#FS">File Systems</a></dt>

<dt>2.2.6 <a href="#AEN874">Contributed Software</a></dt>
</dl>
</dd>

<dt>2.3 <a href="#USERLAND">Userland Changes</a></dt>

<dd>
<dl>
<dt>2.3.1 <a href="#RC-SCRIPTS"><tt class="FILENAME">/etc/rc.d</tt> Scripts</a></dt>
</dl>
</dd>

<dt>2.4 <a href="#CONTRIB">Contributed Software</a></dt>

<dt>2.5 <a href="#PORTS">Ports/Packages Collection Infrastructure</a></dt>

<dt>2.6 <a href="#RELENG">Release Engineering and Integration</a></dt>

<dt>2.7 <a href="#DOC">Documentation</a></dt>
</dl>
</dd>

<dt>3 <a href="#UPGRADE">Upgrading from previous releases of FreeBSD</a></dt>
</dl>
</div>

<div class="SECT1">
<h2 class="SECT1"><a id="INTRO" name="INTRO">1 Introduction</a></h2>

<p>This document contains the release notes for FreeBSD 6.0-RELEASE on the AMD64 hardware
platform. It describes recently added, changed, or deleted features of FreeBSD. It also
provides some notes on upgrading from previous versions of FreeBSD.</p>

<p>This distribution of FreeBSD 6.0-RELEASE is a release distribution. It can be found at
<a href="ftp://ftp.FreeBSD.org/" target="_top">ftp://ftp.FreeBSD.org/</a> or any of its
mirrors. More information on obtaining this (or other) release distributions of FreeBSD
can be found in the <a
href="http://www.FreeBSD.org/doc/en_US.ISO8859-1/books/handbook/mirrors.html"
target="_top">&#8220;Obtaining FreeBSD&#8221; appendix</a> to the <a
href="http://www.FreeBSD.org/doc/en_US.ISO8859-1/books/handbook/" target="_top">FreeBSD
Handbook</a>.</p>

<p>All users are encouraged to consult the release errata before installing FreeBSD. The
errata document is updated with &#8220;late-breaking&#8221; information discovered late
in the release cycle or after the release. Typically, it contains information on known
bugs, security advisories, and corrections to documentation. An up-to-date copy of the
errata for FreeBSD 6.0-RELEASE can be found on the FreeBSD Web site.</p>
</div>

<div class="SECT1">
<hr />
<h2 class="SECT1"><a id="NEW" name="NEW">2 What's New</a></h2>

<p>This section describes the most user-visible new or changed features in FreeBSD since
5.4-RELEASE. In general, changes described here are unique to the 6-STABLE branch unless
specifically marked as [MERGED] features.</p>

<p>Typical release note items document recent security advisories issued after
5.4-RELEASE, new drivers or hardware support, new commands or options, major bug fixes,
or contributed software upgrades. They may also list changes to major ports/packages or
release engineering practices. Clearly the release notes cannot list every single change
made to FreeBSD between releases; this document focuses primarily on security advisories,
user-visible changes, and major architectural improvements.</p>

<div class="SECT2">
<hr />
<h3 class="SECT2"><a id="SECURITY" name="SECURITY">2.1 Security Advisories</a></h3>

<p>A bug in the <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=fetch&sektion=1&manpath=FreeBSD+6.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">fetch</span>(1)</span></a>
utility, which allows a malicious HTTP server to cause arbitrary portions of the client's
memory to be overwritten, has been fixed. For more information, see security advisory <a
href="ftp://ftp.FreeBSD.org/pub/FreeBSD/CERT/advisories/FreeBSD-SA-04:16.fetch.asc"
target="_top">FreeBSD-SA-04:16.fetch</a>. [MERGED]</p>

<p>A bug in <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=procfs&sektion=5&manpath=FreeBSD+6.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">procfs</span>(5)</span></a> and <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=linprocfs&sektion=5&manpath=FreeBSD+6.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">linprocfs</span>(5)</span></a>
which could allow a malicious local user to read parts of kernel memory or perform a
local denial of service attack by causing a system panic, has been fixed. For more
information, see security advisory <a
href="ftp://ftp.FreeBSD.org/pub/FreeBSD/CERT/advisories/FreeBSD-SA-04:17.procfs.asc"
target="_top">FreeBSD-SA-04:17.procfs</a>. [MERGED]</p>

<p>Two buffer overflows in the TELNET client program have been corrected. They could have
allowed a malicious TELNET server or an active network attacker to cause <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=telnet&sektion=1&manpath=FreeBSD+6.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">telnet</span>(1)</span></a> to
execute arbitrary code with the privileges of the user running it. More information can
be found in security advisory <a
href="ftp://ftp.FreeBSD.org/pub/FreeBSD/CERT/advisories/FreeBSD-SA-05:01.telnet.asc"
target="_top">FreeBSD-SA-05:01.telnet</a>. [MERGED]</p>

<p>An information disclosure vulnerability in the <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=sendfile&sektion=2&manpath=FreeBSD+6.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">sendfile</span>(2)</span></a>
system call, which could permit it to transmit random parts of kernel memory, has been
fixed. More details are in security advisory <a
href="ftp://ftp.FreeBSD.org/pub/FreeBSD/CERT/advisories/FreeBSD-SA-05:02.sendfile.asc"
target="_top">FreeBSD-SA-05:02.sendfile</a>. [MERGED]</p>

<p>A possible privilege escalation vulnerability on FreeBSD/amd64 has been fixed. This
allows unprivileged users to gain direct access to some hardware which cannot be accessed
without the elevated privilege level. More details are in security advisory <a
href="ftp://ftp.FreeBSD.org/pub/FreeBSD/CERT/advisories/FreeBSD-SA-05:03.amd64.asc"
target="_top">FreeBSD-SA-05:03.amd64</a>. [MERGED]</p>

<p>An information leak vulnerability in the <tt class="LITERAL">SIOCGIFCONF</tt> <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=ioctl&sektion=2&manpath=FreeBSD+6.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">ioctl</span>(2)</span></a>, which
leaked 12 bytes of kernel memory, has been fixed. More details are in security advisory
<a href="ftp://ftp.FreeBSD.org/pub/FreeBSD/CERT/advisories/FreeBSD-SA-05:04.ifconf.asc"
target="_top">FreeBSD-SA-05:04.ifconf</a>. [MERGED]</p>

<p>Several programming errors in <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=cvs&sektion=1&manpath=FreeBSD+6.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">cvs</span>(1)</span></a>, which
could potentially cause arbitrary code to be executed on CVS servers, have been
corrected. Further information can be found in security advisory <a
href="ftp://ftp.FreeBSD.org/pub/FreeBSD/CERT/advisories/FreeBSD-SA-05:05.cvs.asc"
target="_top">FreeBSD-SA-05:05.cvs</a>. [MERGED]</p>

<p>An error in the default permissions on the <tt class="FILENAME">/dev/iir</tt> device
node, which allowed unprivileged local users can send commands to the hardware supported
by the <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=iir&sektion=4&manpath=FreeBSD+6.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">iir</span>(4)</span></a> driver,
has been fixed. For more information, see security advisory <a
href="ftp://ftp.FreeBSD.org/pub/FreeBSD/CERT/advisories/FreeBSD-SA-05:06.iir.asc"
target="_top">FreeBSD-SA-05:06.iir</a>. [MERGED]</p>

<p>A bug in the validation of <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=i386_get_ldt&sektion=2&manpath=FreeBSD+6.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">i386_get_ldt</span>(2)</span></a>
system call input arguments, which may allow kernel memory to be disclosed to a user
process, has been fixed. For more information, see security advisory <a
href="ftp://ftp.FreeBSD.org/pub/FreeBSD/CERT/advisories/FreeBSD-SA-05:07.ldt.asc"
target="_top">FreeBSD-SA-05:07.ldt</a>. [MERGED]</p>

<p>Several information disclosure vulnerabilities in various parts of the kernel have
been fixed. For more information, see security advisory <a
href="ftp://ftp.FreeBSD.org/pub/FreeBSD/CERT/advisories/FreeBSD-SA-05:08.kmem.asc"
target="_top">FreeBSD-SA-05:08.kmem</a>. [MERGED]</p>

<p>Because of an information disclosure vulnerability on processors using Hyper-Threading
Technology (HTT), the <code class="VARNAME">machdep.hyperthreading_allowed</code> sysctl
variable has been added. It defaults to <tt class="LITERAL">1</tt> (HTT enabled) on
FreeBSD CURRENT, and <tt class="LITERAL">0</tt> (HTT disabled) on the 4-STABLE and
5-STABLE development branches and supported security fix branches. More information can
be found in security advisory <a
href="ftp://ftp.FreeBSD.org/pub/FreeBSD/CERT/advisories/FreeBSD-SA-05:09.htt.asc"
target="_top">FreeBSD-SA-05:09.htt</a>. [MERGED]</p>

<p>A bug in the <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=tcpdump&sektion=1&manpath=FreeBSD+6.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">tcpdump</span>(1)</span></a>
utility which allows a malicious remote user to cause a denial-of-service by using
specially crafted packets, has been fixed. For more information, see security advisory <a
href="ftp://ftp.FreeBSD.org/pub/FreeBSD/CERT/advisories/FreeBSD-SA-05:10.tcpdump.asc"
target="_top">FreeBSD-SA-05:10.tcpdump</a>. [MERGED]</p>

<p>Two problems in the <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=gzip&sektion=1&manpath=FreeBSD+6.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">gzip</span>(1)</span></a> utility
have been fixed. These may allow a local user to modify permissions of arbitrary files
and overwrite arbitrary local files when uncompressing a file. For more information, see
security advisory <a
href="ftp://ftp.FreeBSD.org/pub/FreeBSD/CERT/advisories/FreeBSD-SA-05:11.gzip.asc"
target="_top">FreeBSD-SA-05:11.gzip</a>. [MERGED]</p>

<p>A bug in <b class="APPLICATION">BIND 9</b> DNSSEC has been fixed. When DNSSEC is
enabled, this bug may allow a remote attacker to inject a specially crafted packet which
will cause <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=named&sektion=8&manpath=FreeBSD+6.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">named</span>(8)</span></a> to
terminate. For more information, see security advisory <a
href="ftp://ftp.FreeBSD.org/pub/FreeBSD/CERT/advisories/FreeBSD-SA-05:12.bind9.asc"
target="_top">FreeBSD-SA-05:12.bind9</a>. [MERGED]</p>

<p>A bug has been fixed in <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=ipfw&sektion=4&manpath=FreeBSD+6.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">ipfw</span>(4)</span></a> that
could cause packets to be matched incorrectly against a lookup table. This bug only
affects SMP machines or UP machines that have the <tt class="LITERAL">PREEMPTION</tt>
kernel option enabled. More information is contained in security advisory <a
href="ftp://ftp.FreeBSD.org/pub/FreeBSD/CERT/advisories/FreeBSD-SA-05:13.ipfw.asc"
target="_top">FreeBSD-SA-05:13.ipfw</a>. [MERGED]</p>

<p>Two security-related problems have been fixed in <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=bzip2&sektion=1&manpath=FreeBSD+6.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">bzip2</span>(1)</span></a>. These
include a potential denial of service and unauthorized manipulation of file permissions.
For more information, see security advisory <a
href="ftp://ftp.FreeBSD.org/pub/FreeBSD/CERT/advisories/FreeBSD-SA-05:14.bzip2.asc"
target="_top">FreeBSD-SA-05:14.bzip2</a>. [MERGED]</p>

<p>Two problems in FreeBSD's TCP stack have been fixed. They could allow attackers to
stall existing TCP connections, creating a denial-of-service situation. More information
is contained in security advisory <a
href="ftp://ftp.FreeBSD.org/pub/FreeBSD/CERT/advisories/FreeBSD-SA-05:15.tcp.asc"
target="_top">FreeBSD-SA-05:15.tcp</a>. [MERGED]</p>
</div>

<div class="SECT2">
<hr />
<h3 class="SECT2"><a id="KERNEL" name="KERNEL">2.2 Kernel Changes</a></h3>

<p>The kernel debugger <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=ddb&sektion=4&manpath=FreeBSD+6.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">ddb</span>(4)</span></a> now
supports a <tt class="COMMAND">show alllocks</tt> command, which dumps a list of
processes and threads currently holding sleep mutexes (and spin mutexes for the current
thread). [MERGED]</p>

<p>The kernel crash dump format has been changed to ELF to support large memory (more
than 4GB) environments.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=ichsmb&sektion=4&manpath=FreeBSD+6.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">ichsmb</span>(4)</span></a> driver
is now available as a loadable kernel module.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=jail&sektion=8&manpath=FreeBSD+6.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">jail</span>(8)</span></a> feature
now supports a new sysctl <code class="VARNAME">security.jail.chflags_allowed</code>,
which controls the behavior of <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=chflags&sektion=1&manpath=FreeBSD+6.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">chflags</span>(1)</span></a>
within a jail. If set to <tt class="LITERAL">0</tt> (the default), then a jailed <tt
class="USERNAME">root</tt> user is treated as an unprivileged user; if set to <tt
class="LITERAL">1</tt>, then a jailed root user is treated the same as an unjailed <tt
class="USERNAME">root</tt> user. [MERGED]</p>

<p>A sysctl <code class="VARNAME">security.jail.getfsstatroot_only</code> has been
renamed to <code class="VARNAME">security.jail.enforce_statfs</code> and now supports the
following policies:</p>

<div class="INFORMALTABLE"><a id="AEN154" name="AEN154"></a>
<table border="0" frame="void" class="CALSTABLE">
<col width="1*" />
<col width="3*" />
<thead>
<tr>
<th>Value</th>
<th>Policy</th>
</tr>
</thead>

<tbody>
<tr>
<td>0</td>
<td>Show all mount-points without any restrictions.</td>
</tr>

<tr>
<td>1</td>
<td>Show only mount-points below jail's chroot and show only part of the mount-point's
path (for example, if the jail's chroot directory is <tt class="FILENAME">/jails/foo</tt>
and mount-point is <tt class="FILENAME">/jails/foo/usr/home</tt>, only <tt
class="FILENAME">/usr/home</tt> will be shown).</td>
</tr>

<tr>
<td>2</td>
<td>Show only mount-point where jail's chroot directory is placed.</td>
</tr>
</tbody>
</table>
</div>

<p>The loader tunable <code class="VARNAME">debug.mpsafevm</code> has been enabled by
default. [MERGED]</p>

<p><a
href="http://www.FreeBSD.org/cgi/man.cgi?query=memguard&sektion=9&manpath=FreeBSD+6.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">memguard</span>(9)</span></a>, a
kernel memory allocator designed to help detect &#8220;tamper-after-free&#8221;
scenarios, has been added. This must be explicitly enabled via <tt
class="LITERAL">options DEBUG_MEMGUARD</tt>, plus small kernel modifications. It is
generally intended for use by kernel developers.</p>

<p><code class="VARNAME">struct ifnet</code> and the network interface API have been
changed. Due to ABI incompatibility, all drivers not in the FreeBSD base system need to
be updated to use the new API and recompiled.</p>

<p>A number of bugs have been fixed in the ULE scheduler. [MERGED]</p>

<p>Fine-grained locking to allow much of the VFS stack to run without the Giant lock has
been added. This is enabled by default on the alpha, amd64, and i386 architectures, and
can be disabled by setting the loader tunable (and sysctl variable) <code
class="VARNAME">debug.mpsafevfs</code> to <tt class="LITERAL">0</tt>.</p>

<p>System V IPC objects (message queues, semaphores, and shared memory) now have support
for Mandatory Access Control policies, notably <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=mac_biba&sektion=4&manpath=FreeBSD+6.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">mac_biba</span>(4)</span></a>, <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=mac_mls&sektion=4&manpath=FreeBSD+6.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">mac_mls</span>(4)</span></a>, <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=mac_stub&sektion=4&manpath=FreeBSD+6.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">mac_stub</span>(4)</span></a>, and
<a
href="http://www.FreeBSD.org/cgi/man.cgi?query=mac_test&sektion=4&manpath=FreeBSD+6.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">mac_test</span>(4)</span></a>.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=sysctl&sektion=3&manpath=FreeBSD+6.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">sysctl</span>(3)</span></a> MIBs
beginning with &#8220;debug&#8221; now require the kernel option <tt
class="LITERAL">options SYSCTL_DEBUG</tt>. This option is disabled by default.</p>

<p>The generic <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=tty&sektion=4&manpath=FreeBSD+6.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">tty</span>(4)</span></a> driver
interface has been added and many device drivers including <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=cx&sektion=4&manpath=FreeBSD+6.0-RELEASE"><span
 class="CITEREFENTRY"><span class="REFENTRYTITLE">cx</span>(4)</span></a> (<tt
class="LITERAL">{tty,cua}x</tt>), <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=cy&sektion=4&manpath=FreeBSD+6.0-RELEASE"><span
 class="CITEREFENTRY"><span class="REFENTRYTITLE">cy</span>(4)</span></a> (<tt
class="LITERAL">{tty,cua}c</tt>), <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=digi&sektion=4&manpath=FreeBSD+6.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">digi</span>(4)</span></a> (<tt
class="LITERAL">{tty,cua}D</tt>), <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=rc&sektion=4&manpath=FreeBSD+6.0-RELEASE"><span
 class="CITEREFENTRY"><span class="REFENTRYTITLE">rc</span>(4)</span></a> (<tt
class="LITERAL">{tty,cua}m</tt>), <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=rp&sektion=4&manpath=FreeBSD+6.0-RELEASE"><span
 class="CITEREFENTRY"><span class="REFENTRYTITLE">rp</span>(4)</span></a> (<tt
class="LITERAL">{tty,cua}R</tt>), <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=sab&sektion=4&manpath=FreeBSD+6.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">sab</span>(4)</span></a> (<tt
class="LITERAL">{tty,cua}z</tt>), <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=si&sektion=4&manpath=FreeBSD+6.0-RELEASE"><span
 class="CITEREFENTRY"><span class="REFENTRYTITLE">si</span>(4)</span></a> (<tt
class="LITERAL">{tty,cua}A</tt>), <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=sio&sektion=4&manpath=FreeBSD+6.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">sio</span>(4)</span></a> (<tt
class="LITERAL">{tty,cua}d</tt>), sx (<tt class="LITERAL">{tty,cua}G</tt>), <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=uart&sektion=4&manpath=FreeBSD+6.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">uart</span>(4)</span></a> (<tt
class="LITERAL">{tty,cua}u</tt>), <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=ubser&sektion=4&manpath=FreeBSD+6.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">ubser</span>(4)</span></a> (<tt
class="LITERAL">{tty,cua}y</tt>), <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=ucom&sektion=4&manpath=FreeBSD+6.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">ucom</span>(4)</span></a> (<tt
class="LITERAL">{tty,cua}U</tt>), and <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=ucycom&sektion=4&manpath=FreeBSD+6.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">ucycom</span>(4)</span></a> (<tt
class="LITERAL">{tty,cua}y</tt>) have been rewritten to use it. Note that <tt
class="FILENAME">/etc/remote</tt> and <tt class="FILENAME">/etc/ttys</tt> have been
updated as well.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=vkbd&sektion=4&manpath=FreeBSD+6.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">vkbd</span>(4)</span></a> driver
has been added. This driver provides a software loopback mechanism that can implement a
virtual AT keyboard similar to what the <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=pty&sektion=4&manpath=FreeBSD+6.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">pty</span>(4)</span></a> driver
does for terminals.</p>

<p>FreeBSD always uses the local APIC timer even on uni-processor systems now.</p>

<p>The default <code class="VARNAME">HZ</code> parameter (which controls various kernel
timers) has been increased from <tt class="LITERAL">100</tt> to <tt
class="LITERAL">1000</tt> on the i386 and ia64. It has been reduced from <tt
class="LITERAL">1024</tt> to <tt class="LITERAL">1000</tt> on the amd64 to reduce
synchronization effects with other system clocks.</p>

<p>The maximum length of shell commands has changed from 128 bytes to <code
class="VARNAME">PAGE_SIZE</code>. By default, this value is either 4KB (i386, pc98,
amd64, and powerpc) or 8KB (sparc64 and ia64). As a result, compatibility modules need to
be rebuilt to stay synchronized with data structure changes in the kernel.</p>

<p>A new tunable <code class="VARNAME">vm.blacklist</code> has been added. This can hold
a space or comma separated list of physical addresses. The pages containing these
physical addresses will not be added to the free list and thus will effectively be
ignored by the FreeBSD VM system. The physical addresses of any ignored pages are listed
in the message buffer as well.</p>

<div class="SECT3">
<hr />
<h4 class="SECT3"><a id="BOOT" name="BOOT">2.2.1 Boot Loader Changes</a></h4>

<p>The <tt class="COMMAND">autoboot</tt> loader command now supports the prompt
parameter.</p>

<p>The <tt class="COMMAND">autoboot</tt> loader command will now prevent the user from
interrupting the boot process at all if the <code class="VARNAME">autoboot_delay</code>
variable is set to <tt class="LITERAL">-1</tt>. [MERGED]</p>

<p>A loader menu option to set <code class="VARNAME">hint.atkbd.0.flags=0x1</code> has
been added. This setting allows USB keyboards to work if no PS/2 keyboard is
attached.</p>

<p>The beastie boot menu has been disabled by default.</p>
</div>

<div class="SECT3">
<hr />
<h4 class="SECT3"><a id="PROC" name="PROC">2.2.2 Hardware Support</a></h4>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=acpi&sektion=4&manpath=FreeBSD+6.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">acpi</span>(4)</span></a> driver
now turns the ACPI and PCI devices off or to a lower power state when suspending, and
back on again when resuming. This behavior can be disabled by setting the <code
class="VARNAME">debug.acpi.do_powerstate</code> and <code
class="VARNAME">hw.pci.do_powerstate</code> sysctls to <tt class="LITERAL">0</tt>.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=acpi_ibm&sektion=4&manpath=FreeBSD+6.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">acpi_ibm</span>(4)</span></a>
driver for IBM laptops has been added. It provides support for the various hotkeys and
reading fan status and thermal sensors.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=acpi_fujitsu&sektion=4&manpath=FreeBSD+6.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">acpi_fujitsu</span>(4)</span></a>
driver for handling <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=acpi&sektion=4&manpath=FreeBSD+6.0-RELEASE">
<span class="CITEREFENTRY"><span
class="REFENTRYTITLE">acpi</span>(4)</span></a>-controlled buttons on Fujitsu laptops has
been added.</p>

<p>The acpi_sony driver, which supports the Sony Notebook Controller on various Sony
laptops has been added.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=atkbdc&sektion=4&manpath=FreeBSD+6.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">atkbdc</span>(4)</span></a>, <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=atkbd&sektion=4&manpath=FreeBSD+6.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">atkbd</span>(4)</span></a>, and <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=psm&sektion=4&manpath=FreeBSD+6.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">psm</span>(4)</span></a> drivers
have been rewritten in more bus-independent way, and now support the EBus found on the
sparc64 platform.</p>

<p>A framework for flexible processor speed control has been added. It provides methods
for various drivers to control CPU power utilization by adjusting the processor speed.
More details can be found in the <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=cpufreq&sektion=4&manpath=FreeBSD+6.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">cpufreq</span>(4)</span></a>
manual page. [MERGED] Currently supported drivers include ichss (Intel SpeedStep for
ICH), acpi_perf (ACPI CPU performance states), and acpi_throttle (ACPI CPU throttling).
The latter two drivers are contained in the <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=acpi&sektion=4&manpath=FreeBSD+6.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">acpi</span>(4)</span></a> driver.
These can individually be disabled by setting device hints such as <code
class="VARNAME">hint.<tt class="REPLACEABLE"><i>ichss</i></tt>.0.disabled="1"</code>.</p>

<p>Support for the PadLock Security Co-processor in VIA C3 processors has been added to
the <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=crypto&sektion=9&manpath=FreeBSD+6.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">crypto</span>(9)</span></a>
subsystem.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=hwpmc&sektion=4&manpath=FreeBSD+6.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">hwpmc</span>(4)</span></a>
hardware performance monitoring counter driver has been added. This driver virtualizes
the hardware performance monitoring facilities in modern CPUs and provides support for
using these facilities from user level processes. For more details, see manual pages of
<a
href="http://www.FreeBSD.org/cgi/man.cgi?query=hwpmc&sektion=4&manpath=FreeBSD+6.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">hwpmc</span>(4)</span></a>,
associated libraries, and associated userland utilities.</p>

<p>The pcii driver has been added to support GPIB-PCIIA IEEE-488 cards. [MERGED]</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=atkbd&sektion=4&manpath=FreeBSD+6.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">atkbd</span>(4)</span></a> driver
now supports a <tt class="LITERAL">0x8</tt> (bit 3) flag to disable testing the keyboard
port during the device probe as this can cause hangs on some machines, specifically
Compaq R3000Z series amd64 laptops.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=psm&sektion=4&manpath=FreeBSD+6.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">psm</span>(4)</span></a> driver
now has improved support for Synaptics Touchpad users. It now has better tracking of
slow-speed movement and support for various extra buttons and dials. These features can
be tuned with the <code class="VARNAME">hw.psm.synaptics.<tt
class="REPLACEABLE"><i>*</i></tt></code> hierarchy of sysctl variables.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=uftdi&sektion=4&manpath=FreeBSD+6.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">uftdi</span>(4)</span></a> driver
now supports the FTDI FT2232C chip.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=uplcom&sektion=4&manpath=FreeBSD+6.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">uplcom</span>(4)</span></a> driver
now supports handling of the <tt class="LITERAL">CTS</tt> signal.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=ehci&sektion=4&manpath=FreeBSD+6.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">ehci</span>(4)</span></a> driver
has been improved.</p>

<div class="SECT4">
<hr />
<h5 class="SECT4"><a id="MM" name="MM">2.2.2.1 Multimedia Support</a></h5>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=snd_csa&sektion=4&manpath=FreeBSD+6.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">snd_csa</span>(4)</span></a>
driver now supports suspend and resume operation.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=uaudio&sektion=4&manpath=FreeBSD+6.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">uaudio</span>(4)</span></a> driver
now has some added functionality, including volume control on more inputs and recording
capability on some devices. [MERGED]</p>
</div>

<div class="SECT4">
<hr />
<h5 class="SECT4"><a id="NET-IF" name="NET-IF">2.2.2.2 Network Interface Support</a></h5>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=ath&sektion=4&manpath=FreeBSD+6.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">ath</span>(4)</span></a> driver
has been updated to split the transmit rate control algorithm into a separate module. One
of <tt class="LITERAL">device ath_rate_onoe</tt>, <tt class="LITERAL">device
ath_rate_amrr</tt>, or <tt class="LITERAL">device ath_rate_sample</tt> must be included
in the kernel configuration when using the <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=ath&sektion=4&manpath=FreeBSD+6.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">ath</span>(4)</span></a>
driver.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=bge&sektion=4&manpath=FreeBSD+6.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">bge</span>(4)</span></a> driver
now supports the <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=altq&sektion=4&manpath=FreeBSD+6.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">altq</span>(4)</span></a>
framework, as well as the BCM5714, 5721, 5750, 5751, 5751M and 5789 chips. [MERGED]</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=cdce&sektion=4&manpath=FreeBSD+6.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">cdce</span>(4)</span></a> USB
Communication Device Class Ethernet driver has been added. [MERGED]</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=cp&sektion=4&manpath=FreeBSD+6.0-RELEASE"><span
 class="CITEREFENTRY"><span class="REFENTRYTITLE">cp</span>(4)</span></a> driver is now
MPSAFE. [MERGED]</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=ctau&sektion=4&manpath=FreeBSD+6.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">ctau</span>(4)</span></a> driver
is now MPSAFE. [MERGED]</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=cx&sektion=4&manpath=FreeBSD+6.0-RELEASE"><span
 class="CITEREFENTRY"><span class="REFENTRYTITLE">cx</span>(4)</span></a> driver is now
MPSAFE. [MERGED]</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=dc&sektion=4&manpath=FreeBSD+6.0-RELEASE"><span
 class="CITEREFENTRY"><span class="REFENTRYTITLE">dc</span>(4)</span></a> driver now
supports the <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=altq&sektion=4&manpath=FreeBSD+6.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">altq</span>(4)</span></a>
framework and is MPSAFE. [MERGED]</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=de&sektion=4&manpath=FreeBSD+6.0-RELEASE"><span
 class="CITEREFENTRY"><span class="REFENTRYTITLE">de</span>(4)</span></a> driver is now
MPSAFE.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=ed&sektion=4&manpath=FreeBSD+6.0-RELEASE"><span
 class="CITEREFENTRY"><span class="REFENTRYTITLE">ed</span>(4)</span></a> driver now
supports the <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=altq&sektion=4&manpath=FreeBSD+6.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">altq</span>(4)</span></a>
framework. [MERGED]</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=ed&sektion=4&manpath=FreeBSD+6.0-RELEASE"><span
 class="CITEREFENTRY"><span class="REFENTRYTITLE">ed</span>(4)</span></a> driver is now
MPSAFE.</p>

<p>In the <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=em&sektion=4&manpath=FreeBSD+6.0-RELEASE"><span
 class="CITEREFENTRY"><span class="REFENTRYTITLE">em</span>(4)</span></a> driver,
hardware support for VLAN tagging is now disabled by default due to some interactions
between this feature and promiscuous mode. [MERGED]</p>

<p>Ethernet flow control is now disabled by default in the <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=fxp&sektion=4&manpath=FreeBSD+6.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">fxp</span>(4)</span></a> driver,
to prevent problems on a subnet when a system panics or is left in the kernel debugger.
[MERGED]</p>

<p>The gx(4) driver has been removed because it is no longer maintained actively and the
<a
href="http://www.FreeBSD.org/cgi/man.cgi?query=em&sektion=4&manpath=FreeBSD+6.0-RELEASE"><span
 class="CITEREFENTRY"><span class="REFENTRYTITLE">em</span>(4)</span></a> driver supports
all of the supported hardware.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=hme&sektion=4&manpath=FreeBSD+6.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">hme</span>(4)</span></a> driver is
now MPSAFE. [MERGED]</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=ipw&sektion=4&manpath=FreeBSD+6.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">ipw</span>(4)</span></a> (for
Intel PRO/Wireless 2100), <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=iwi&sektion=4&manpath=FreeBSD+6.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">iwi</span>(4)</span></a> (for
Intel PRO/Wireless 2200BG/2225BG/2915ABG), <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=ral&sektion=4&manpath=FreeBSD+6.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">ral</span>(4)</span></a> (for
Ralink Technology RT2500), and <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=ural&sektion=4&manpath=FreeBSD+6.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">ural</span>(4)</span></a> (for
Ralink Technology RT2500USB) drivers have been added.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=ixgb&sektion=4&manpath=FreeBSD+6.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">ixgb</span>(4)</span></a> driver
is now MPSAFE. [MERGED]</p>

<p>The musycc driver, for the LanMedia LMC1504 T1/E1 network interface card, has been
removed due to disuse.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=my&sektion=4&manpath=FreeBSD+6.0-RELEASE"><span
 class="CITEREFENTRY"><span class="REFENTRYTITLE">my</span>(4)</span></a> driver is now
MPSAFE.</p>

<p>Drivers using the <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=ndis&sektion=4&manpath=FreeBSD+6.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">ndis</span>(4)</span></a> device
driver wrapper mechanism are now built and loaded differently. The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=ndis&sektion=4&manpath=FreeBSD+6.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">ndis</span>(4)</span></a> driver
can now be pre-built as a module or statically compiled into a kernel. Individual drivers
can now be built with the <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=ndisgen&sektion=8&manpath=FreeBSD+6.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">ndisgen</span>(8)</span></a>
utility; the result is a kernel module that can be loaded into a running kernel using <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=kldload&sektion=8&manpath=FreeBSD+6.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">kldload</span>(8)</span></a>.
[MERGED]</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=ndis&sektion=4&manpath=FreeBSD+6.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">ndis</span>(4)</span></a> device
driver wrapper now supports <span class="TRADEMARK">Windows</span>&reg;/x86-64 binaries
on amd64 systems. [MERGED]</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=nve&sektion=4&manpath=FreeBSD+6.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">nve</span>(4)</span></a> driver,
which supports the nVidia nForce MCP Networking Adapter, has been added.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=pcn&sektion=4&manpath=FreeBSD+6.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">pcn</span>(4)</span></a> driver is
now MPSAFE.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=re&sektion=4&manpath=FreeBSD+6.0-RELEASE"><span
 class="CITEREFENTRY"><span class="REFENTRYTITLE">re</span>(4)</span></a> driver now
supports the <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=altq&sektion=4&manpath=FreeBSD+6.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">altq</span>(4)</span></a>
framework. [MERGED]</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=sf&sektion=4&manpath=FreeBSD+6.0-RELEASE"><span
 class="CITEREFENTRY"><span class="REFENTRYTITLE">sf</span>(4)</span></a> driver now has
support for device polling and <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=altq&sektion=4&manpath=FreeBSD+6.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">altq</span>(4)</span></a> and is
MPSAFE. [MERGED]</p>

<p>Several programming errors in the <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=sk&sektion=4&manpath=FreeBSD+6.0-RELEASE"><span
 class="CITEREFENTRY"><span class="REFENTRYTITLE">sk</span>(4)</span></a> driver have
been corrected. These bugs were particular to SMP systems, and could cause panics, page
faults, aborted SSH connections, or corrupted file transfers. More details can be found
in errata note <a
href="ftp://ftp.FreeBSD.org/pub/FreeBSD/ERRATA/notices/FreeBSD-EN-05:02.sk.asc"
target="_top">FreeBSD-EN-05:02.sk</a>. [MERGED]</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=sk&sektion=4&manpath=FreeBSD+6.0-RELEASE"><span
 class="CITEREFENTRY"><span class="REFENTRYTITLE">sk</span>(4)</span></a> driver now has
support for <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=altq&sektion=4&manpath=FreeBSD+6.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">altq</span>(4)</span></a>. This
driver also now supports jumbo frames on Yukon-based interfaces. [MERGED]</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=ste&sektion=4&manpath=FreeBSD+6.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">ste</span>(4)</span></a> driver
now has support for <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=altq&sektion=4&manpath=FreeBSD+6.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">altq</span>(4)</span></a>.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=vge&sektion=4&manpath=FreeBSD+6.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">vge</span>(4)</span></a> driver
now has support for device polling (<a
href="http://www.FreeBSD.org/cgi/man.cgi?query=polling&sektion=4&manpath=FreeBSD+6.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">polling</span>(4)</span></a>).</p>

<p>Support for 802.11 devices in the <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=wlan&sektion=4&manpath=FreeBSD+6.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">wlan</span>(4)</span></a>
framework has been greatly overhauled. In addition to architectural changes, it includes
completed 802.11g, WPA, 802.11i, 802.1x, WME/WMM, AP-side power-saving, and plugin
frameworks for cryptography modules, authenticators, and access control. Note in
particular that WEP now requires the <tt class="FILENAME">wlan_wep</tt> module to be
loaded (or compiled) into the kernel.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=xl&sektion=4&manpath=FreeBSD+6.0-RELEASE"><span
 class="CITEREFENTRY"><span class="REFENTRYTITLE">xl</span>(4)</span></a> driver now
supports <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=polling&sektion=4&manpath=FreeBSD+6.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">polling</span>(4)</span></a>.
[MERGED]</p>
</div>
</div>

<div class="SECT3">
<hr />
<h4 class="SECT3"><a id="NET-PROTO" name="NET-PROTO">2.2.3 Network Protocols</a></h4>

<p>The MTU feedback in IPv6 has been disabled when the sender writes data that must be
fragmented. [MERGED]</p>

<p>The Common Address Redundancy Protocol (CARP) has been implemented. CARP comes from
OpenBSD and allows multiple hosts to share an IP address, providing high availability and
load balancing. For more information, see the <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=carp&sektion=4&manpath=FreeBSD+6.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">carp</span>(4)</span></a> manual
page. [MERGED]</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=if_bridge&sektion=4&manpath=FreeBSD+6.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">if_bridge</span>(4)</span></a>
network bridging implementation, originally from NetBSD, has been added. It supports the
IEEE 802.1D Spanning Tree Protocol, individual interface devices for each bridge, and
filtering of bridged packets. The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=ifconfig&sektion=8&manpath=FreeBSD+6.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">ifconfig</span>(8)</span></a>
utility now supports configuration of <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=if_bridge&sektion=4&manpath=FreeBSD+6.0-RELEASE">
<span class="CITEREFENTRY"><span
class="REFENTRYTITLE">if_bridge</span>(4)</span></a>.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=ipfw&sektion=4&manpath=FreeBSD+6.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">ipfw</span>(4)</span></a> <tt
class="LITERAL">IPDIVERT</tt> option is now available as a kernel loadable module. If
this module is not loaded, <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=ipfw&sektion=4&manpath=FreeBSD+6.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">ipfw</span>(4)</span></a> will
refuse to install <tt class="LITERAL">divert</tt> rules and <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=natd&sektion=8&manpath=FreeBSD+6.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">natd</span>(8)</span></a> will
return the error message &#8220;protocol not supported&#8221;.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=ipfw&sektion=4&manpath=FreeBSD+6.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">ipfw</span>(4)</span></a> system
can work with <code class="VARNAME">debug.mpsafenet</code>=<tt class="LITERAL">1</tt>
(this tunable is <tt class="LITERAL">1</tt> by default) when the <tt
class="LITERAL">gid</tt>, <tt class="LITERAL">jail</tt>, and/or <tt
class="LITERAL">uid</tt> rule options are used. [MERGED]</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=ipfw&sektion=4&manpath=FreeBSD+6.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">ipfw</span>(4)</span></a> and <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=dummynet&sektion=4&manpath=FreeBSD+6.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">dummynet</span>(4)</span></a>
systems now support IPv6.</p>

<p><a
href="http://www.FreeBSD.org/cgi/man.cgi?query=ipfw&sektion=8&manpath=FreeBSD+6.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">ipfw</span>(8)</span></a> now
supports classification and tagging of <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=altq&sektion=4&manpath=FreeBSD+6.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">altq</span>(4)</span></a> packets
via a divert socket. It is also possible to specify rules that match TCP packets with
specific payload sizes.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=ipfw&sektion=8&manpath=FreeBSD+6.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">ipfw</span>(8)</span></a> <tt
class="LITERAL">ipfw fwd</tt> rule now supports the full packet destination manipulation
when the kernel option <tt class="LITERAL">options IPFIREWALL_FORWARD_EXTENDED</tt> is
specified in addition to <tt class="LITERAL">options IPFIRWALL_FORWARD</tt>. This kernel
option disables all restrictions to ensure proper behavior for locally generated packets
and allows redirection of packets destined to locally configured IP addresses. Note that
<a
href="http://www.FreeBSD.org/cgi/man.cgi?query=ipfw&sektion=8&manpath=FreeBSD+6.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">ipfw</span>(8)</span></a> rules
have to be carefully crafted to make sure that things like PMTU discovery do not break.
[MERGED]</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=ipfw&sektion=8&manpath=FreeBSD+6.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">ipfw</span>(8)</span></a> system
now supports IPv4 only rules.</p>

<p><a
href="http://www.FreeBSD.org/cgi/man.cgi?query=ipnat&sektion=8&manpath=FreeBSD+6.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">ipnat</span>(8)</span></a> now
allows redirect rules to work for non-TCP/UDP packets. [MERGED]</p>

<p>Ongoing work is reducing the use of the Giant lock by the network protocol stack and
improving the locking strategies.</p>

<p>The <tt class="FILENAME">libalias</tt> library can now be built as a kernel
module.</p>

<p>The link state change notifications of network interfaces are sent to <tt
class="FILENAME">/dev/devctl</tt> now.</p>

<p>A new <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=ng_ipfw&sektion=4&manpath=FreeBSD+6.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">ng_ipfw</span>(4)</span></a>
NetGraph node provides a simple interface between the <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=ipfw&sektion=4&manpath=FreeBSD+6.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">ipfw</span>(4)</span></a> and <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=netgraph&sektion=4&manpath=FreeBSD+6.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">netgraph</span>(4)</span></a>
facilities.</p>

<p>A new <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=ng_nat&sektion=4&manpath=FreeBSD+6.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">ng_nat</span>(4)</span></a>
NetGraph node has been added to perform NAT functions.</p>

<p>A new <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=ng_netflow&sektion=4&manpath=FreeBSD+6.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">ng_netflow</span>(4)</span></a>
NetGraph node allows a router running FreeBSD to do NetFlow version 5 exports.
[MERGED]</p>

<p>A new <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=ng_tcpmss&sektion=4&manpath=FreeBSD+6.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">ng_tcpmss</span>(4)</span></a>
NetGraph node has been added. This supports altering MSS options of TCP packets.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=sppp&sektion=4&manpath=FreeBSD+6.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">sppp</span>(4)</span></a> driver
now includes Frame Relay support. [MERGED]</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=sppp&sektion=4&manpath=FreeBSD+6.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">sppp</span>(4)</span></a> driver
is now MPSAFE.</p>

<p>The FreeBSD routing table now requires gateways for routes to be of the same address
family as the route itself. The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=route&sektion=8&manpath=FreeBSD+6.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">route</span>(8)</span></a> utility
now rejects a combination of different address families. For example:</p>

<pre class="SCREEN">
<samp class="PROMPT">#</samp> route add 10.1.1.1 -inet6 fe80::1%fxp0
</pre>

<p>The new sysctl <code class="VARNAME">net.link.tap.user_open</code> has been
implemented. This allows unprivileged access to <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=tap&sektion=4&manpath=FreeBSD+6.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">tap</span>(4)</span></a> device
nodes based on file system permissions.</p>

<p>A bug in TCP that sometimes caused RST packets to be ignored if the receive window was
zero bytes has been fixed. [MERGED]</p>

<p>The <tt class="LITERAL">RST</tt> handling of the FreeBSD TCP stack has been improved
to make reset attacks as difficult as possible while maintaining compatibility with the
widest range of TCP stacks. The algorithm is as follows: For connections in the <tt
class="LITERAL">ESTABLISHED</tt> state, only resets with sequence numbers exactly
matching <code class="VARNAME">last_ack_sent</code> will cause a reset; all other
segments will be silently dropped. For connections in all other states, a reset anywhere
in the window will cause the connection to be reset. All other segments will be silently
dropped. Note that this behavior technically violates the RFC 793 specification; the
conventional (but less secure) behavior can be restored by setting a new sysctl <code
class="VARNAME">net.inet.tcp.insecure_rst</code> to <tt class="LITERAL">1</tt>.
[MERGED]</p>

<p>Several bugs in the TCP SACK implementation have been fixed. [MERGED]</p>

<p>RFC 1644 T/TCP support has been removed. This is because the design is based on a weak
security model that can easily permit denial-of-service attacks. This TCP extension has
been considered a defective one in a recent Internet Draft.</p>

<p>The KAME IPv4 IPsec implementation integrated in FreeBSD now supports TCP-MD5.
[MERGED]</p>

<p>Random ephemeral port number allocation has led to some problems with port reuse at
high connection rates. This feature is now disabled during periods of high connection
rates; whenever new connections are created faster than <code
class="VARNAME">net.inet.ip.portrange.randomcps</code> per second, port number
randomization is disabled for the next <code
class="VARNAME">net.inet.ip.portrange.randomtime</code> seconds. The default values for
these two sysctl variables are <tt class="LITERAL">10</tt> and <tt
class="LITERAL">45</tt>, respectively. [MERGED]</p>

<p>Fine-grained locking has been applied to many of the data structures in the IPX/SPX
protocol stack. While not fully MPSAFE at this point, it is generally safe to use IPX/SPX
without the Giant lock (in other words, the <code class="VARNAME">debug.mpsafenet</code>
sysctl variable may be set to <tt class="LITERAL">1</tt>).</p>

<p>Unix domain sockets now support the <tt class="LITERAL">LOCAL_CREDS</tt> and <tt
class="LITERAL">LOCAL_CONNWAIT</tt> options. The <tt class="LITERAL">LOCAL_CREDS</tt>
option provides a mechanism for the receiver to receive the credentials of the process as
a <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=recvmsg&sektion=2&manpath=FreeBSD+6.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">recvmsg</span>(2)</span></a>
control message. The <tt class="LITERAL">LOCAL_CONNWAIT</tt> option causes the <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=connect&sektion=2&manpath=FreeBSD+6.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">connect</span>(2)</span></a>
function to block until <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=accept&sektion=2&manpath=FreeBSD+6.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">accept</span>(2)</span></a> has
been called on the listening socket. For more details, see the <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=unix&sektion=4&manpath=FreeBSD+6.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">unix</span>(4)</span></a> manual
page.</p>
</div>

<div class="SECT3">
<hr />
<h4 class="SECT3"><a id="DISKS" name="DISKS">2.2.4 Disks and Storage</a></h4>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=amr&sektion=4&manpath=FreeBSD+6.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">amr</span>(4)</span></a> driver is
now safe for use on systems using <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=pae&sektion=4&manpath=FreeBSD+6.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">pae</span>(4)</span></a>.
[MERGED]</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=ata&sektion=4&manpath=FreeBSD+6.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">ata</span>(4)</span></a> family of
drivers has been overhauled and updated. It has been split into modules that can be
loaded and unloaded independently (the <tt class="FILENAME">atapci</tt> and <tt
class="FILENAME">ata</tt> modules are prerequisites for the device subdrivers, which are
<tt class="FILENAME">atadisk</tt>, <tt class="FILENAME">atapicd</tt>, <tt
class="FILENAME">atapifd</tt>, <tt class="FILENAME">atapist</tt>, and <tt
class="FILENAME">ataraid</tt>). On supported SATA controllers, devices can be hot
inserted/removed. ATA RAID support has been rewritten and supports a number of new
metadata formats. The <tt class="FILENAME">atapicd</tt> driver no longer supports CD
changers. This update has been referred to as &#8220;ATA mkIII&#8221;.</p>

<p>The SHSEC GEOM class has been added. It provides for the sharing of a secret between
multiple GEOM providers. All of these providers must be present in order to reveal the
secret. This feature is controlled by the <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=gshsec&sektion=8&manpath=FreeBSD+6.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">gshsec</span>(8)</span></a>
utility. [MERGED]</p>

<p>A new GEOM-based disk encryption facility, GEOM_ELI, has been added. It uses the <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=crypto&sektion=9&manpath=FreeBSD+6.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">crypto</span>(9)</span></a>
framework for hardware acceleration and supports different cryptographic algorithms. See
<a
href="http://www.FreeBSD.org/cgi/man.cgi?query=geli&sektion=8&manpath=FreeBSD+6.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">geli</span>(8)</span></a> for more
information. [MERGED]</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=hptmv&sektion=4&manpath=FreeBSD+6.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">hptmv</span>(4)</span></a> driver,
which supports the HighPoint RocketRAID 182x series, has been added. [MERGED]</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=ips&sektion=4&manpath=FreeBSD+6.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">ips</span>(4)</span></a> driver
now support kernel crash dumps on some modern ServeRAID models. [MERGED]</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=matcd&sektion=4&manpath=FreeBSD+6.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">matcd</span>(4)</span></a> driver
has been removed. [MERGED]</p>

<p>The default SCSI boot-time probe delay in the <tt class="FILENAME">GENERIC</tt> kernel
has been reduced from fifteen seconds to five seconds.</p>

<p>The old vinum(4) subsystem has been removed in favor of the new <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=geom&sektion=4&manpath=FreeBSD+6.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">geom</span>(4)</span></a>-based
version.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=twa&sektion=4&manpath=FreeBSD+6.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">twa</span>(4)</span></a> driver
has been updated to the 9.2 release (for FreeBSD 5.2.1) distributed from the 3ware
website.</p>

<p>Information about newly-mounted cd9660 file systems (such as the presence of RockRidge
extensions) is now only printed if the kernel was booted in verbose mode. This change was
made to reduce the amount of (generally unnecessary) kernel log messages. [MERGED]</p>
</div>

<div class="SECT3">
<hr />
<h4 class="SECT3"><a id="FS" name="FS">2.2.5 File Systems</a></h4>

<p>Recomputing the summary information for &#8220;dirty&#8221; UFS and UFS2 file systems
is no longer done at mount time, but is now done by background <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=fsck&sektion=8&manpath=FreeBSD+6.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">fsck</span>(8)</span></a>. This
change improves the startup speed when mounting large file systems after a crash. The
prior behavior can be restored by setting the <code
class="VARNAME">vfs.ffs.compute_summary_at_mount</code> sysctl variable to a non-zero
value. [MERGED]</p>

<p>A kernel panic in the NFS server has been fixed. More details can be found in errata
note <a href="ftp://ftp.FreeBSD.org/pub/FreeBSD/ERRATA/notices/FreeBSD-EN-05:01.nfs.asc"
target="_top">FreeBSD-EN-05:01.nfs</a>. [MERGED]</p>
</div>

<div class="SECT3">
<hr />
<h4 class="SECT3"><a id="AEN874" name="AEN874">2.2.6 Contributed Software</a></h4>

<p><b class="APPLICATION">ACPI-CA</b> has been updated from 20040527 to 20041119.
[MERGED]</p>
</div>
</div>

<div class="SECT2">
<hr />
<h3 class="SECT2"><a id="USERLAND" name="USERLAND">2.3 Userland Changes</a></h3>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=bsdiff&sektion=1&manpath=FreeBSD+6.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">bsdiff</span>(1)</span></a> and <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=bspatch&sektion=1&manpath=FreeBSD+6.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">bspatch</span>(1)</span></a>
binary diff and binary patching tools have been added.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=burncd&sektion=8&manpath=FreeBSD+6.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">burncd</span>(8)</span></a>
utility now allows commands (such as <tt class="COMMAND">eject</tt>) to take place after
fixating a disk.</p>

<p>Machine-specific optimized versions of <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=bcmp&sektion=3&manpath=FreeBSD+6.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">bcmp</span>(3)</span></a>, <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=bcopy&sektion=3&manpath=FreeBSD+6.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">bcopy</span>(3)</span></a>, <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=bzero&sektion=3&manpath=FreeBSD+6.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">bzero</span>(3)</span></a>, <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=memcmp&sektion=3&manpath=FreeBSD+6.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">memcmp</span>(3)</span></a>, <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=memcpy&sektion=3&manpath=FreeBSD+6.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">memcpy</span>(3)</span></a>, <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=memmove&sektion=3&manpath=FreeBSD+6.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">memmove</span>(3)</span></a>, <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=memset&sektion=3&manpath=FreeBSD+6.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">memset</span>(3)</span></a>, <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=strcat&sektion=3&manpath=FreeBSD+6.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">strcat</span>(3)</span></a> and <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=strcpy&sektion=3&manpath=FreeBSD+6.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">strcpy</span>(3)</span></a> have
been implemented. Several mathematics functions such as <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=ceill&sektion=3&manpath=FreeBSD+6.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">ceill</span>(3)</span></a> and <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=sqrtf&sektion=3&manpath=FreeBSD+6.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">sqrtf</span>(3)</span></a> are
also replaced with the optimized versions.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=chflags&sektion=1&manpath=FreeBSD+6.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">chflags</span>(1)</span></a>
utility now supports the <code class="OPTION">-h</code> flag, which supports changing
flags on symbolic links.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=env&sektion=1&manpath=FreeBSD+6.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">env</span>(1)</span></a> program
now supports a <code class="OPTION">-v</code> flag to write the command to standard error
before it is executed.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=env&sektion=1&manpath=FreeBSD+6.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">env</span>(1)</span></a> program
now supports a <code class="OPTION">-S <tt class="REPLACEABLE"><i>string</i></tt></code>
option to split the <tt class="REPLACEABLE"><i>string</i></tt> and pass them to the
command as the command-line arguments.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=env&sektion=1&manpath=FreeBSD+6.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">env</span>(1)</span></a> program
now supports a <code class="OPTION">-P <tt class="REPLACEABLE"><i>altpath</i></tt></code>
option to set the command search path used to look for the command.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=ftpd&sektion=8&manpath=FreeBSD+6.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">ftpd</span>(8)</span></a> program
now uses the <tt class="LITERAL">212</tt> and <tt class="LITERAL">213</tt> status codes
for directory and file status correctly (<tt class="LITERAL">211</tt> was used in the
previous versions). This behavior is described in RFC 959. [MERGED]</p>

<p>The <tt class="LITERAL">create</tt> command of the <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=gpt&sektion=8&manpath=FreeBSD+6.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">gpt</span>(8)</span></a> utility
now supports a <code class="OPTION">-f</code> command-line flag to force creation of a
GPT even when there is an MBR record on a disk. [MERGED]</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=getaddrinfo&sektion=3&manpath=FreeBSD+6.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">getaddrinfo</span>(3)</span></a>
function now queries <tt class="LITERAL">A</tt> DNS resource records before <tt
class="LITERAL">AAAA</tt> records when <tt class="LITERAL">AF_UNSPEC</tt> is specified.
Some broken DNS servers return <tt class="LITERAL">NXDOMAIN</tt> against non-existent <tt
class="LITERAL">AAAA</tt> queries, even when it should return <tt
class="LITERAL">NOERROR</tt> with empty return records. This is a problem for an
IPv4/IPv6 dual stack node because the <tt class="LITERAL">NXDOMAIN</tt> returned by the
first query of an <tt class="LITERAL">AAAA</tt> record makes the querying server stop
attempting to resolve the <tt class="LITERAL">A</tt> record if any. Also, this behavior
has been recognized as a potential denial-of-service attack (see <a
href="http://www.kb.cert.org/vuls/id/714121"
target="_top">http://www.kb.cert.org/vuls/id/714121</a> for more details). Note that
although the query order has been changed, the returned result still includes <tt
class="LITERAL">AF_INET6</tt> records before <tt class="LITERAL">AF_INET</tt> records.
[MERGED]</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=gethostbyname&sektion=3&manpath=FreeBSD+6.0-RELEASE">
<span class="CITEREFENTRY"><span
class="REFENTRYTITLE">gethostbyname</span>(3)</span></a>, <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=gethostbyname2&sektion=3&manpath=FreeBSD+6.0-RELEASE">
<span class="CITEREFENTRY"><span
class="REFENTRYTITLE">gethostbyname2</span>(3)</span></a>, and <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=gethostbyaddr&sektion=3&manpath=FreeBSD+6.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">gethostbyaddr</span>(3)</span></a>
functions are now thread-safe. [MERGED]</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=getnetent&sektion=3&manpath=FreeBSD+6.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">getnetent</span>(3)</span></a>, <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=getnetbyname&sektion=3&manpath=FreeBSD+6.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">getnetbyname</span>(3)</span></a>,
and <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=getnetbyaddr&sektion=3&manpath=FreeBSD+6.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">getnetbyaddr</span>(3)</span></a>
functions are now thread-safe. [MERGED]</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=getprotoent&sektion=3&manpath=FreeBSD+6.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">getprotoent</span>(3)</span></a>,
<a
href="http://www.FreeBSD.org/cgi/man.cgi?query=getprotobyname&sektion=3&manpath=FreeBSD+6.0-RELEASE">
<span class="CITEREFENTRY"><span
class="REFENTRYTITLE">getprotobyname</span>(3)</span></a>, and <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=getprotobynumber&sektion=3&manpath=FreeBSD+6.0-RELEASE">
<span class="CITEREFENTRY"><span
class="REFENTRYTITLE">getprotobynumber</span>(3)</span></a> functions are now
thread-safe. [MERGED]</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=getservent&sektion=3&manpath=FreeBSD+6.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">getservent</span>(3)</span></a>,
<a
href="http://www.FreeBSD.org/cgi/man.cgi?query=getservbyname&sektion=3&manpath=FreeBSD+6.0-RELEASE">
<span class="CITEREFENTRY"><span
class="REFENTRYTITLE">getservbyname</span>(3)</span></a>, and <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=getservbyport&sektion=3&manpath=FreeBSD+6.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">getservbyport</span>(3)</span></a>
functions are now thread-safe. [MERGED]</p>

<p>For conformation to IEEE Std 1003.1-2001 (also known as POSIX 2001), the <code
class="VARNAME">n_net</code> member of <code class="VARNAME">struct netent</code> and the
first argument of <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=getnetbyaddr&sektion=3&manpath=FreeBSD+6.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">getnetbyaddr</span>(3)</span></a>
has been changed to an <tt class="LITERAL">uint32_t</tt>. Due to these changes, the ABI
on 64-bit platforms is incompatible with previous releases of FreeBSD and the major
version number of the <tt class="FILENAME">libpcap</tt> shared library has been bumped.
On 64-bit platforms being upgraded from older FreeBSD versions, all userland programs
that use <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=getnetbyaddr&sektion=3&manpath=FreeBSD+6.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">getnetbyaddr</span>(3)</span></a>,
<a
href="http://www.FreeBSD.org/cgi/man.cgi?query=getnetbyname&sektion=3&manpath=FreeBSD+6.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">getnetbyname</span>(3)</span></a>,
<a
href="http://www.FreeBSD.org/cgi/man.cgi?query=getnetent&sektion=3&manpath=FreeBSD+6.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">getnetent</span>(3)</span></a>,
and/or <tt class="FILENAME">libpcap</tt> have to be recompiled.</p>

<p>The gvinum(8) utility now supports the <tt class="COMMAND">checkparity</tt>, <tt
class="COMMAND">rebuildparity</tt>, and <tt class="COMMAND">setstate</tt> subcommands.
[MERGED]</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=ifconfig&sektion=8&manpath=FreeBSD+6.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">ifconfig</span>(8)</span></a>
utility has been restructured. It is now more modular and flexible with respect to
supporting interface-specific functionality. The 802.11 support has been updated to
support recent changes to the 802.11 subsystem and drivers.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=ifconfig&sektion=8&manpath=FreeBSD+6.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">ifconfig</span>(8)</span></a>
utility now supports a <code class="OPTION">-tunnel</code> parameter, which is just an
alias for <code class="OPTION">deletetunnel</code>, yet is more convenient and easier to
type.</p>

<p>The <code class="OPTION">-vlandev</code> parameter to <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=ifconfig&sektion=8&manpath=FreeBSD+6.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">ifconfig</span>(8)</span></a> no
longer requires a network interface as its argument. The argument still is supported for
backward compatibility, but now it is deprecated and its use is discouraged.</p>

<p>Support for abbreviated forms of a number of <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=ipfw&sektion=8&manpath=FreeBSD+6.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">ipfw</span>(8)</span></a> options
has been deprecated. Warnings are printed to stderr indicating the correct full form when
one of these abbreviations is detected.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=kldstat&sektion=8&manpath=FreeBSD+6.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">kldstat</span>(8)</span></a>
utility now supports a <code class="OPTION">-m</code> option to return the status of a
specific kernel module. [MERGED]</p>

<p>The on-disk format of <tt class="LITERAL">LC_CTYPE</tt> files has been changed to be
machine-independent.</p>

<p>The <b class="APPLICATION">libkvm</b> now supports ELF crash dumps on amd64 and i386
platforms, large crash dumps (more than 4GB) on 32-bit platforms, and PAE crash dumps on
i386 platform.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=mixer&sektion=8&manpath=FreeBSD+6.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">mixer</span>(8)</span></a> utility
now supports the <code class="OPTION">-S</code> option. This is the same as the <code
class="OPTION">-s</code> option but does not output mixing field separators.</p>

<p>A bug in the <tt class="FILENAME">libalias</tt> library which causes a core dump when
the <code class="OPTION">-reverse</code> option is specified in <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=natd&sektion=8&manpath=FreeBSD+6.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">natd</span>(8)</span></a> has been
fixed.</p>

<p>The <tt class="FILENAME">libarchive</tt> library (as well as the <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=tar&sektion=1&manpath=FreeBSD+6.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">tar</span>(1)</span></a> command
that uses it) now has support for reading ISO images (with optional RockRidge extensions)
and ZIP archives (with <tt class="LITERAL">deflate</tt> and <tt class="LITERAL">none</tt>
compression). [MERGED]</p>

<p>The <tt class="FILENAME">libarchive</tt> library now supports handling a ZIP archive
entry with more than 4GB compressed size (ZIP64 extension) and Unix extension.</p>

<p>The <tt class="FILENAME">libgpib</tt> library has been added to give userland access
to GPIB devices (using the the pcii driver) via the <code class="FUNCTION">ib<tt
class="REPLACEABLE"><i>foo</i></tt></code> API. [MERGED]</p>

<p>The default stack sizes in <tt class="FILENAME">libpthread</tt>, <tt
class="FILENAME">libthr</tt>, and <tt class="FILENAME">libc_r</tt> have been increased.
On 32-bit platforms, the main thread receives a 2MB stack size by default, with other
threads receiving a 1MB stack size by default. On 64-bit platforms, the default stack
sizes are 4MB and 2MB respectively. [MERGED]</p>

<p>The <tt class="FILENAME">libxpg4</tt> library has been removed because all of its
functionality was long ago merged into <tt class="FILENAME">libc</tt>. All binaries
linked with <tt class="FILENAME">libxpg4</tt> must be recompiled or use <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=libmap.conf&sektion=5&manpath=FreeBSD+6.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">libmap.conf</span>(5)</span></a>.
Note that the FreeBSD base system has no such binaries.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=lpd&sektion=8&manpath=FreeBSD+6.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">lpd</span>(8)</span></a> program
now checks to make sure the data file has been completely transfered before starting to
print it when a data file received from some other host. Some implementations of <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=lpr&sektion=1&manpath=FreeBSD+6.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">lpr</span>(1)</span></a> send the
control file for a print job before sending the matching data files, which can cause
problems if the receiving host is a busy print-server. [MERGED]</p>

<p>A number of new functions have been implemented in the <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=math&sektion=3&manpath=FreeBSD+6.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">math</span>(3)</span></a> library.
These include <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=ceill&sektion=3&manpath=FreeBSD+6.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">ceill</span>(3)</span></a>, <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=floorl&sektion=3&manpath=FreeBSD+6.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">floorl</span>(3)</span></a>, <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=ilogbl&sektion=3&manpath=FreeBSD+6.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">ilogbl</span>(3)</span></a>, <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=fma&sektion=3&manpath=FreeBSD+6.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">fma</span>(3)</span></a> and
variants, <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=lrint&sektion=3&manpath=FreeBSD+6.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">lrint</span>(3)</span></a> and
variants, and <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=lround&sektion=3&manpath=FreeBSD+6.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">lround</span>(3)</span></a> and
variants. [MERGED]</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=mknod&sektion=8&manpath=FreeBSD+6.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">mknod</span>(8)</span></a> utility
is now deprecated. Device nodes have been managed by the <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=devfs&sektion=5&manpath=FreeBSD+6.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">devfs</span>(5)</span></a> device
file system since FreeBSD 5.0.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=moused&sektion=8&manpath=FreeBSD+6.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">moused</span>(8)</span></a> daemon
now supports &#8220;virtual scrolling&#8221;, in which mouse motions made while holding
down the middle mouse button are interpreted as scrolling. This feature is enabled with
the <code class="OPTION">-V</code> flag. [MERGED]</p>

<p>A separate directory has been added for <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=named&sektion=8&manpath=FreeBSD+6.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">named</span>(8)</span></a> dynamic
zones which is owned by the <tt class="USERNAME">bind</tt> user (for creation of the zone
journal file). For more detail, see an example dynamic zone in the sample <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=named.conf&sektion=5&manpath=FreeBSD+6.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">named.conf</span>(5)</span></a>.
[MERGED]</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=ncal&sektion=1&manpath=FreeBSD+6.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">ncal</span>(1)</span></a> utility
now supports a <code class="OPTION">-m</code> flag to generate a calendar for a specified
month in the current year. [MERGED]</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=newfs&sektion=8&manpath=FreeBSD+6.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">newfs</span>(8)</span></a> utility
now supports a <code class="OPTION">-n</code> flag to suppress the creation of a <tt
class="FILENAME">.snap</tt> directory on new file systems. This feature is intended for
use on memory or vnode file systems that will not require snapshot support. [MERGED]</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=newfs&sektion=8&manpath=FreeBSD+6.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">newfs</span>(8)</span></a> utility
now emits a warning when creating a UFS or UFS2 file system that cannot support
snapshots. This situation can occur in the case of very large file systems with small
block sizes. [MERGED]</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=newsyslog&sektion=8&manpath=FreeBSD+6.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">newsyslog</span>(8)</span></a>
utility now supports a <code class="OPTION">-d</code> option to specify an alternate root
for log files similar to <code class="VARNAME">DESTDIR</code> in the BSD make process.
This only affects log file paths, not configuration file (<code class="OPTION">-f</code>)
or archive directory (<code class="OPTION">-a</code>) paths.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=newsyslog&sektion=8&manpath=FreeBSD+6.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">newsyslog</span>(8)</span></a>
utility now supports a option <code class="OPTION">-N</code> that causes it not to rotate
any files.</p>

<p>The <tt class="LITERAL">NO_NIS</tt> compile-time knob for userland has been added. As
its name implies, enabling this <tt class="FILENAME">Makefile</tt> variable will cause
NIS support to be excluded from various programs and will cause the NIS utilities to not
be built. [MERGED]</p>

<p>For years, FreeBSD has used <tt class="FILENAME">Makefile</tt> variables of the form
<code class="VARNAME">NO<tt class="REPLACEABLE"><i>FOO</i></tt></code> and <code
class="VARNAME">NO_<tt class="REPLACEABLE"><i>FOO</i></tt></code>. For consistency, those
variables using the former naming convention have been converted to the <code
class="VARNAME">NO_<tt class="REPLACEABLE"><i>FOO</i></tt></code> form. The file <tt
class="FILENAME">/usr/share/mk/bsd.compat.mk</tt> has a complete list of these variables;
it also implements some temporary backward compatibility for the old names.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=periodic&sektion=8&manpath=FreeBSD+6.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">periodic</span>(8)</span></a>
security output now supports the display of information about blocked packet counts from
<a
href="http://www.FreeBSD.org/cgi/man.cgi?query=pf&sektion=4&manpath=FreeBSD+6.0-RELEASE"><span
 class="CITEREFENTRY"><span class="REFENTRYTITLE">pf</span>(4)</span></a>. [MERGED]</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=pgrep&sektion=1&manpath=FreeBSD+6.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">pgrep</span>(1)</span></a> command
now supports a <code class="OPTION">-S</code> option which allows matching system
processes (kernel threads).</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=pgrep&sektion=1&manpath=FreeBSD+6.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">pgrep</span>(1)</span></a> and <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=pkill&sektion=1&manpath=FreeBSD+6.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">pkill</span>(1)</span></a>
commands now support a <code class="OPTION">-F</code> option, which matches a process
whose PID is stored in a file.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=pgrep&sektion=1&manpath=FreeBSD+6.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">pgrep</span>(1)</span></a> and <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=pkill&sektion=1&manpath=FreeBSD+6.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">pkill</span>(1)</span></a>
commands now support a <code class="OPTION">-i</code> option to ignore case in the
process match.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=pgrep&sektion=1&manpath=FreeBSD+6.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">pgrep</span>(1)</span></a> and <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=pkill&sektion=1&manpath=FreeBSD+6.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">pkill</span>(1)</span></a>
commands now support a <code class="OPTION">-j</code> option that matches processes based
on their <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=jail&sektion=2&manpath=FreeBSD+6.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">jail</span>(2)</span></a> ID.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=pgrep&sektion=1&manpath=FreeBSD+6.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">pgrep</span>(1)</span></a> and <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=pkill&sektion=1&manpath=FreeBSD+6.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">pkill</span>(1)</span></a>
commands now support a <code class="OPTION">-o</code> option which matches only the
oldest (least recently started) of the matching processes.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=portsnap&sektion=8&manpath=FreeBSD+6.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">portsnap</span>(8)</span></a>
utility for downloading, updating, and extracting compressed snapshots of the FreeBSD
ports tree has been added.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=powerd&sektion=8&manpath=FreeBSD+6.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">powerd</span>(8)</span></a>
program for managing power consumption has been added.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=ppp&sektion=8&manpath=FreeBSD+6.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">ppp</span>(8)</span></a> program
now implements an <code class="OPTION">echo</code> parameter, which allows LCP ECHOs to
be enabled independently of LQR reports. Older versions of <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=ppp&sektion=8&manpath=FreeBSD+6.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">ppp</span>(8)</span></a> would
revert to LCP ECHO mode on negotiation failure. It is now necessary to specify <tt
class="COMMAND">enable echo</tt> to get this behavior. [MERGED]</p>

<p>The <code class="OPTION">disable NAS-IP-Address</code> and <code
class="OPTION">disable NAS-Identifier</code> options, which support pre-RFC 2865 RADIUS
servers have been added to the <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=ppp&sektion=8&manpath=FreeBSD+6.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">ppp</span>(8)</span></a>
program.</p>

<p>Two bugs in the <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=pppd&sektion=8&manpath=FreeBSD+6.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">pppd</span>(8)</span></a> program
have been fixed. They may result in an incorrect CBCP response, which violates the
Microsoft PPP Callback Control Protocol section 3.2. [MERGED]</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=ps&sektion=1&manpath=FreeBSD+6.0-RELEASE"><span
 class="CITEREFENTRY"><span class="REFENTRYTITLE">ps</span>(1)</span></a> utility now
supports a <tt class="LITERAL">jid</tt> keyword in the <code class="OPTION">-o</code>
option. It displays the <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=jail&sektion=2&manpath=FreeBSD+6.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">jail</span>(2)</span></a> ID of
each process.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=pstat&sektion=8&manpath=FreeBSD+6.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">pstat</span>(8)</span></a> program
now supports a <code class="OPTION">-h</code> option to print swap sizes with SI prefixes
such as K, M, and G, which are used to form binary multiples.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=rescue&sektion=8&manpath=FreeBSD+6.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">rescue</span>(8)</span></a>
utilities in the <tt class="FILENAME">/rescue</tt> directory now include <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=bsdtar&sektion=1&manpath=FreeBSD+6.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">bsdtar</span>(1)</span></a>
instead of GNU tar.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=restore&sektion=8&manpath=FreeBSD+6.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">restore</span>(8)</span></a>
utility has regained the ability to read FreeBSD version 1 dump tapes. [MERGED]</p>

<p>A bug of the <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=rexecd&sektion=8&manpath=FreeBSD+6.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">rexecd</span>(8)</span></a>
utility which results in it behaving as if the <code class="OPTION">-i</code> option is
always specified has been fixed. [MERGED]</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=rexecd&sektion=8&manpath=FreeBSD+6.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">rexecd</span>(8)</span></a>
utility has been removed. There are no rexec clients in the FreeBSD tree, and the client
function <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=rexec&sektion=3&manpath=FreeBSD+6.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">rexec</span>(3)</span></a> is
present only in <tt class="FILENAME">libcompat</tt>.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=rm&sektion=1&manpath=FreeBSD+6.0-RELEASE"><span
 class="CITEREFENTRY"><span class="REFENTRYTITLE">rm</span>(1)</span></a> utility now
supports an <code class="OPTION">-I</code> option that asks for confirmation (once) if
recursively removing directories or if more than 3 files are listed in the command line.
[MERGED]</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=rm&sektion=1&manpath=FreeBSD+6.0-RELEASE"><span
 class="CITEREFENTRY"><span class="REFENTRYTITLE">rm</span>(1)</span></a> utility now
suppresses diagnostic messages when it attempts to remove a non-existent directory with
the <code class="OPTION">-r</code> and <code class="OPTION">-f</code> options specified.
This behavior is required by Version 3 of the Single UNIX Specification (SUSv3).</p>

<p>The following ISO/IEC 9899:1999 standard functions have been implemented: <code
class="FUNCTION">roundl()</code>, <code class="FUNCTION">lroundl()</code>, <code
class="FUNCTION">llroundl()</code>, <code class="FUNCTION">truncl()</code>, and <code
class="FUNCTION">floorl()</code>.</p>

<p>An <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=rpmatch&sektion=3&manpath=FreeBSD+6.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">rpmatch</span>(3)</span></a>
library function has been added to check a string for being an affirmative or negative
response in the current locale.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=rtld&sektion=1&manpath=FreeBSD+6.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">rtld</span>(1)</span></a> dynamic
linker now supports specifying library replacements via the <code
class="VARNAME">LD_LIBMAP</code> environment variable. This variable will override the
entries in <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=libmap.conf&sektion=5&manpath=FreeBSD+6.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">libmap.conf</span>(5)</span></a>.
[MERGED]</p>

<p>The rune(3) non-standard multibyte and wide character support interface has been
removed.</p>

<p><a
href="http://www.FreeBSD.org/cgi/man.cgi?query=sed&sektion=1&manpath=FreeBSD+6.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">sed</span>(1)</span></a> now
supports a <code class="OPTION">-l</code> option to make its output line-buffered.
[MERGED]</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=strftime&sektion=3&manpath=FreeBSD+6.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">strftime</span>(3)</span></a>
function now supports some GNU extensions such as <tt class="LITERAL">-</tt> (no
padding), <tt class="LITERAL">_</tt> (use space as padding), and <tt
class="LITERAL">0</tt> (zero padding). [MERGED]</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=syslog&sektion=3&manpath=FreeBSD+6.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">syslog</span>(3)</span></a>
function is now thread-safe. [MERGED]</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=syslogd&sektion=8&manpath=FreeBSD+6.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">syslogd</span>(8)</span></a>
utility now opens an additional domain socket (<tt class="FILENAME">/var/run/logpriv</tt>
by default), with <tt class="LITERAL">0600</tt> permissions to be used by privileged
programs. This prevents privileged programs from locking when the domain sockets run out
of buffer space due to a local denial-of-service attack. [MERGED]</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=syslogd&sektion=8&manpath=FreeBSD+6.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">syslogd</span>(8)</span></a> now
supports the <code class="OPTION">-S</code> option, which changes the pathname of the
privileged socket. This is useful for preventing the daemon from receiving any messages
from the local sockets (<tt class="FILENAME">/var/run/log</tt> and <tt
class="FILENAME">/var/run/logpriv</tt> are used by default). [MERGED]</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=syslogd&sektion=8&manpath=FreeBSD+6.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">syslogd</span>(8)</span></a>
utility now allows <tt class="LITERAL">:</tt> and <tt class="LITERAL">%</tt> characters
in the hostname specifications. These characters are used in IPv6 addresses and scope
IDs. [MERGED]</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=systat&sektion=1&manpath=FreeBSD+6.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">systat</span>(1)</span></a> <code
class="OPTION">-netstat</code> display is now IPv6-aware. [MERGED]</p>

<p>The <code class="OPTION">-f</code> option of <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=tail&sektion=1&manpath=FreeBSD+6.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">tail</span>(1)</span></a> utility
now supports more than one file at a time. [MERGED]</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=telnet&sektion=1&manpath=FreeBSD+6.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">telnet</span>(1)</span></a> and <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=telnetd&sektion=8&manpath=FreeBSD+6.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">telnetd</span>(8)</span></a>
programs now support the <code class="OPTION">-S</code> option for specifying a numeric
TOS byte.</p>

<p>Prepending a <tt class="LITERAL">+</tt> character to port numbers passed to <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=telnet&sektion=1&manpath=FreeBSD+6.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">telnet</span>(1)</span></a>
program will now disable option negotiation and allow the transfer of characters with the
high bit set. This feature is intended to support the fairly common use of <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=telnet&sektion=1&manpath=FreeBSD+6.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">telnet</span>(1)</span></a> as a
protocol tester.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=tcpdrop&sektion=8&manpath=FreeBSD+6.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">tcpdrop</span>(8)</span></a>
command, which closes a selected TCP connection, has been added. It was obtained from
OpenBSD. [MERGED]</p>

<p><a
href="http://www.FreeBSD.org/cgi/man.cgi?query=what&sektion=1&manpath=FreeBSD+6.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">what</span>(1)</span></a> now
supports a <code class="OPTION">-q</code> flag, which causes it to print matching text,
but not format it.</p>

<p><a
href="http://www.FreeBSD.org/cgi/man.cgi?query=whois&sektion=1&manpath=FreeBSD+6.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">whois</span>(1)</span></a> now
supports a <code class="OPTION">-k</code> flag for querying <tt
class="HOSTID">whois.krnic.net</tt> (the National Internet Development Agency of Korea),
which holds details of IP address allocations within Korea. [MERGED]</p>

<p>The <code class="OPTION">-I</code> option of the <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=xargs&sektion=1&manpath=FreeBSD+6.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">xargs</span>(1)</span></a> command
has been changed to conform to IEEE Std 1003.1-2004. The standard requires that the
constructed arguments cannot grow larger than 255 bytes.</p>

<p>A bug, which caused the last line of configuration files such as <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=hosts&sektion=5&manpath=FreeBSD+6.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">hosts</span>(5)</span></a>, <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=services&sektion=5&manpath=FreeBSD+6.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">services</span>(5)</span></a>, and
so on to be ignored if it did not end in a newline character, has been fixed.
[MERGED]</p>

<p>A new system user/group <tt class="USERNAME">_dhcp</tt> has been added to support <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=dhclient&sektion=8&manpath=FreeBSD+6.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">dhclient</span>(8)</span></a> from
OpenBSD.</p>

<div class="SECT3">
<hr />
<h4 class="SECT3"><a id="RC-SCRIPTS" name="RC-SCRIPTS">2.3.1 <tt
class="FILENAME">/etc/rc.d</tt> Scripts</a></h4>

<p>The <tt class="FILENAME">rc.d/bsnmpd</tt> startup script for <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=bsnmpd&sektion=1&manpath=FreeBSD+6.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">bsnmpd</span>(1)</span></a> has
been added.</p>

<p>The <tt class="FILENAME">rc.d/jail</tt> startup script now supports <code
class="VARNAME">jail_<tt class="REPLACEABLE"><i>name</i></tt>_flags</code> variable which
allows to specify <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=jail&sektion=8&manpath=FreeBSD+6.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">jail</span>(8)</span></a> flags.
[MERGED]</p>

<p><a
href="http://www.FreeBSD.org/cgi/man.cgi?query=rc.conf&sektion=5&manpath=FreeBSD+6.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">rc.conf</span>(5)</span></a> now
supports changes of network interface names at boot time. [MERGED] For example:</p>

<pre class="PROGRAMLISTING">
ifconfig_fxp0_name="net0"
ifconfig_net0="inet 10.0.0.1/16"
</pre>

<p>The <tt class="FILENAME">rc.d/moused</tt> script now starts/stops/checks a specific
device when the device name is given as the second argument to the script:</p>

<pre class="SCREEN">
<samp class="PROMPT">#</samp> /etc/rc.d/moused start ums0
</pre>

<p>To use different <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=rc.conf&sektion=5&manpath=FreeBSD+6.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">rc.conf</span>(5)</span></a> knobs
with different mice, use the device name as part of the knob. For example, if the mouse
device is <tt class="FILENAME">/dev/ums0</tt> the following lines can be used:</p>

<pre class="PROGRAMLISTING">
moused_ums0_enable=yes
moused_ums0_flags="-z 4"
moused_ums0_port="/dev/ums0"
</pre>

<p><a
href="http://www.FreeBSD.org/cgi/man.cgi?query=rc.conf&sektion=5&manpath=FreeBSD+6.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">rc.conf</span>(5)</span></a> now
supports the <code class="VARNAME">tmpmfs_flags</code> and <code
class="VARNAME">varmfs_flags</code> variables. These can be used to pass extra options to
the <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=mdmfs&sektion=8&manpath=FreeBSD+6.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">mdmfs</span>(8)</span></a>
utility, to customize the finer details of the <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=md&sektion=4&manpath=FreeBSD+6.0-RELEASE"><span
 class="CITEREFENTRY"><span class="REFENTRYTITLE">md</span>(4)</span></a> file system
creation, such as to turn on/off softupdates, to specify a default owner for the file
system, and so on. [MERGED]</p>

<p>The following scripts have been removed because they were NetBSD specific and never
used in FreeBSD: <tt class="FILENAME">altqd</tt>, <tt class="FILENAME">dhcpd</tt>, <tt
class="FILENAME">dhcrelay</tt>, <tt class="FILENAME">downinterfaces</tt>, <tt
class="FILENAME">gated</tt>, <tt class="FILENAME">ifwatchd</tt>, <tt
class="FILENAME">kdc</tt>, <tt class="FILENAME">lkm1</tt>, <tt
class="FILENAME">lkm2</tt>, <tt class="FILENAME">lkm3</tt>, <tt
class="FILENAME">mixerctl</tt>, <tt class="FILENAME">mopd</tt>, <tt
class="FILENAME">mountall</tt>, <tt class="FILENAME">ndbootd</tt>, <tt
class="FILENAME">network</tt>, <tt class="FILENAME">poffd</tt>, <tt
class="FILENAME">postfix</tt>, <tt class="FILENAME">ppp</tt>, <tt
class="FILENAME">racoon</tt>, <tt class="FILENAME">raidframe</tt>, <tt
class="FILENAME">rbootd</tt>, <tt class="FILENAME">rtsold</tt>, <tt
class="FILENAME">screenblank</tt>, <tt class="FILENAME">swap2</tt>, <tt
class="FILENAME">sysdb</tt>, <tt class="FILENAME">wscons</tt>, <tt
class="FILENAME">xdm</tt>, and <tt class="FILENAME">xfs</tt></p>
</div>
</div>

<div class="SECT2">
<hr />
<h3 class="SECT2"><a id="CONTRIB" name="CONTRIB">2.4 Contributed Software</a></h3>

<p><b class="APPLICATION">awk</b> has been updated from the 7 February 2004 release to
the 24 April 2005 release.</p>

<p><b class="APPLICATION">BIND</b> has been updated from version 9.3.0 to version 9.3.1.
[MERGED]</p>

<p><b class="APPLICATION">bsnmp</b> has been updated from 1.7 to 1.10.</p>

<p><b class="APPLICATION">bzip2</b> has been updated from 1.0.2 to 1.0.3.</p>

<p><b class="APPLICATION">OpenBSD dhclient</b> as of OpenBSD 3.7 has been imported. It
replaces the ISC DHCP client used in prior versions of FreeBSD.</p>

<p><b class="APPLICATION">FILE</b> has been updated from 4.10 to 4.12.</p>

<p><b class="APPLICATION">GNU GCC</b> has been updated from from 3.4.2-prerelease as of
28 July, 2004 to 3.4.4.</p>

<p>A number of bug fixes and performance enhancements have been added to <b
class="APPLICATION">GNU grep</b> in the form of patches from Fedora's grep-2.5.1-48
source RPM.</p>

<p><b class="APPLICATION">GNU readline</b> has been updated from version 4.3 to version
5.0.</p>

<p><b class="APPLICATION">IPFilter</b> has been updated from 3.4.35 to 4.1.18.</p>

<p><b class="APPLICATION">Heimdal</b> has been updated from 0.6.1 to 0.6.3. [MERGED]</p>

<p>The <b class="APPLICATION">hostapd</b> v0.3.9 has been imported. This is a user space
IEEE 802.11 AP and IEEE 802.1X/WPA/WPA2/EAP Authenticator and RADIUS authentication
server. For more details, see <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=hostapd&sektion=8&manpath=FreeBSD+6.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">hostapd</span>(8)</span></a>.</p>

<p><b class="APPLICATION">libpcap</b> has been updated from v0.8.3 to v0.9.1 (alpha
096).</p>

<p><b class="APPLICATION">libregex</b> has been updated from a snapshot from <b
class="APPLICATION">GNU grep</b> 2.5.1 to a snapshot from the <tt
class="LITERAL">fedora-glibc-2_3_4-21</tt> tag in the <b class="APPLICATION">glibc</b>
CVS repository.</p>

<p><b class="APPLICATION">libz</b> has been updated from 1.2.1 to 1.2.2.</p>

<p><b class="APPLICATION">lukemftp</b> has been updated from a 26 April 2004 snapshot
from NetBSD's sources to a snapshot as of 16 May 2005.</p>

<p>A snapshot of <b class="APPLICATION">netcat</b> from OpenBSD as of 4 February 2005 has
been added. More information can be found in the <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=nc&sektion=1&manpath=FreeBSD+6.0-RELEASE"><span
 class="CITEREFENTRY"><span class="REFENTRYTITLE">nc</span>(1)</span></a> manual page.
[MERGED]</p>

<p><b class="APPLICATION">NgATM</b> has been updated from 1.0 to 1.2.</p>

<p><b class="APPLICATION">OpenPAM</b> has been updated from the Eelgrass release to the
Figwort release.</p>

<p><b class="APPLICATION">OpenSSH</b> has been updated from 3.8p1 to 4.1p1.</p>

<p><b class="APPLICATION">OpenSSL</b> has been updated from 0.9.7d to 0.9.7e.
[MERGED]</p>

<p><b class="APPLICATION">pf</b> has been updated from the version included with <b
class="APPLICATION">OpenBSD</b> 3.5 to the version included with <b
class="APPLICATION">OpenBSD</b> 3.7.</p>

<p><b class="APPLICATION">sendmail</b> has been updated from version 8.13.3 to version
8.13.4. It now supports <tt class="LITERAL">OSTYPE(freebsd6)</tt>.</p>

<p><b class="APPLICATION">tcpdump</b> has been updated from v3.8.3 to v3.9.1 (alpha
096).</p>

<p><b class="APPLICATION">tcsh</b> has been updated from 6.13.00 to 6.14.00.</p>

<p><b class="APPLICATION">texinfo</b> has been updated from 4.6 to 4.8.</p>

<p>The timezone database has been updated from the <b class="APPLICATION">tzdata2004e</b>
release to the <b class="APPLICATION">tzdata2004g</b> release. [MERGED]</p>

<p>The <b class="APPLICATION">WPA Supplicant</b> v0.3.9 has been imported. This provides
WPA Supplicant component of WPA/IEEE 802.11i features. For more details, see <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=wpa_supplicant&sektion=8&manpath=FreeBSD+6.0-RELEASE">
<span class="CITEREFENTRY"><span
class="REFENTRYTITLE">wpa_supplicant</span>(8)</span></a>.</p>
</div>

<div class="SECT2">
<hr />
<h3 class="SECT2"><a id="PORTS" name="PORTS">2.5 Ports/Packages Collection
Infrastructure</a></h3>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=pkg_create&sektion=1&manpath=FreeBSD+6.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">pkg_create</span>(1)</span></a>
utility now supports a <code class="OPTION">-R</code> flag. When creating a package file
from the locally installed package, it creates package files for all packages on which
that locally installed package depends if this flag is specified.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=pkg_version&sektion=1&manpath=FreeBSD+6.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">pkg_version</span>(1)</span></a>
utility now supports a <code class="OPTION">-q</code> flag to suppress the output of the
port version comparison characters <tt class="LITERAL">&lt;</tt>, <tt
class="LITERAL">=</tt>, and <tt class="LITERAL">&gt;</tt>.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=pkg_version&sektion=1&manpath=FreeBSD+6.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">pkg_version</span>(1)</span></a>
utility now supports a <code class="OPTION">-I</code> flag, which causes only the <tt
class="FILENAME">INDEX</tt> file to be used for determining if a package is out of date.
[MERGED]</p>

<p>The <tt class="FILENAME">ports/INDEX<tt class="REPLACEABLE"><i>*</i></tt></tt> files,
which kept an index of all of the entries in the ports collection, have been removed from
the CVS repository. [MERGED] These files were generated only infrequently, and therefore
were usually out-of-date and inaccurate. Users requiring an index file (such as for use
by programs such as <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=portupgrade&sektion=1&manpath=FreeBSD+Ports">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">portupgrade</span>(1)</span></a>)
have two alternatives for obtaining a copy:</p>

<ul>
<li>
<p>Build an index file based on the current ports tree by running <tt
class="COMMAND">make index</tt> from the top of the <tt class="FILENAME">ports/</tt>
tree.</p>
</li>

<li>
<p>Fetch an index file over the network by running <tt class="COMMAND">make
fetchindex</tt> from the top of the <tt class="FILENAME">ports/</tt> tree. This index
file will (typically) be accurate to within a day.</p>
</li>
</ul>
</div>

<div class="SECT2">
<hr />
<h3 class="SECT2"><a id="RELENG" name="RELENG">2.6 Release Engineering and
Integration</a></h3>

<p>In prior FreeBSD releases, the <tt class="FILENAME">disc1</tt> CD-ROM (or ISO image)
was a bootable installation disk containing the base system, ports tree, and common
packages. The <tt class="FILENAME">disc2</tt> CD-ROM (or ISO image) was a bootable
&#8220;fix it&#8221; disk with a live filesystem, to be used for making emergency
repairs. This layout has now changed. For all architectures except ia64, the <tt
class="FILENAME">disc1</tt> image now contains the base system distribution files, ports
tree, and the live filesystem, making it suitable for both an initial installation and
repair purposes. (On the ia64, the live filesystem is on a separate disk due to its
size.) Packages appear on separate disks; in particular, the <tt
class="FILENAME">disc2</tt> image contains commonly packages such as desktop
environments. Documents from the FreeBSD Documentation Project also appear on <tt
class="FILENAME">disc2</tt>. [MERGED]</p>

<p>The supported version of the <b class="APPLICATION">GNOME</b> desktop environment has
been updated from 2.6.2 to 2.10.2. More information about running <b
class="APPLICATION">GNOME</b> on FreeBSD can be found on the <a
href="http://www.FreeBSD.org/gnome/" target="_top">FreeBSD GNOME Project</a> Web page.
[MERGED]</p>

<div class="NOTE">
<blockquote class="NOTE">
<p><b>Note:</b> Users of older versions of the <b class="APPLICATION">GNOME</b> desktop
(<a href="http://www.FreeBSD.org/cgi/url.cgi?ports/x11/gnome2/pkg-descr"><tt
class="FILENAME">x11/gnome2</tt></a>) must take particular care in upgrading. Simply
upgrading it from the FreeBSD Ports Collection with <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=portupgrade&sektion=1&manpath=FreeBSD+Ports">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">portupgrade</span>(1)</span></a>
(<a href="http://www.FreeBSD.org/cgi/url.cgi?ports/sysutils/portupgrade/pkg-descr"><tt
class="FILENAME">sysutils/portupgrade</tt></a>) will cause serious problems. <b
class="APPLICATION">GNOME</b> desktop users should read the instructions carefully at <a
href="http://www.FreeBSD.org/gnome/docs/faq210.html"
target="_top">http://www.FreeBSD.org/gnome/docs/faq210.html</a> and use the <a
href="http://www.FreeBSD.org/gnome/gnome_upgrade.sh" target="_top"><tt
class="FILENAME">gnome_upgrade.sh</tt></a> script to properly upgrade to <b
class="APPLICATION">GNOME</b> 2.10.</p>
</blockquote>
</div>

<br />
<br />
<p>The supported version of the <b class="APPLICATION">KDE</b> desktop environment has
been updated from 3.3.0 to 3.4.2. More information regarding running <b
class="APPLICATION">KDE</b> on FreeBSD can be found on the <a
href="http://freebsd.kde.org/" target="_top">KDE on FreeBSD</a> Web page. [MERGED]</p>

<div class="NOTE">
<blockquote class="NOTE">
<p><b>Note:</b> Users of older versions of <b class="APPLICATION">KDE</b> should follow
the upgrading procedure documented on the <a href="http://freebsd.kde.org/"
target="_top">KDE on FreeBSD</a> Web page or in <tt
class="FILENAME">ports/UPDATING</tt>.</p>
</blockquote>
</div>

<br />
<br />
<p>The supported version of <b class="APPLICATION">Xorg</b> has been updated from 6.7.0
to 6.8.2. [MERGED]</p>
</div>

<div class="SECT2">
<hr />
<h3 class="SECT2"><a id="DOC" name="DOC">2.7 Documentation</a></h3>

<p>Documentation of existing functionality has been improved by the addition of the
following manual pages: <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=acpi_ibm&sektion=4&manpath=FreeBSD+6.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">acpi_ibm</span>(4)</span></a>, <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=acpi_sony&sektion=4&manpath=FreeBSD+6.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">acpi_sony</span>(4)</span></a>, <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=ataraid&sektion=4&manpath=FreeBSD+6.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">ataraid</span>(4)</span></a>, <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=bus_space&sektion=9&manpath=FreeBSD+6.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">bus_space</span>(9)</span></a>, <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=central&sektion=4&manpath=FreeBSD+6.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">central</span>(4)</span></a>, <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=clkbrd&sektion=4&manpath=FreeBSD+6.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">clkbrd</span>(4)</span></a>, <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=creator&sektion=4&manpath=FreeBSD+6.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">creator</span>(4)</span></a>, <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=devfs.conf&sektion=5&manpath=FreeBSD+6.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">devfs.conf</span>(5)</span></a>,
<a
href="http://www.FreeBSD.org/cgi/man.cgi?query=devfs.rules&sektion=5&manpath=FreeBSD+6.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">devfs.rules</span>(5)</span></a>,
<a
href="http://www.FreeBSD.org/cgi/man.cgi?query=ebus&sektion=4&manpath=FreeBSD+6.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">ebus</span>(4)</span></a>, <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=eeprom&sektion=4&manpath=FreeBSD+6.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">eeprom</span>(4)</span></a>, <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=fhc&sektion=4&manpath=FreeBSD+6.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">fhc</span>(4)</span></a>, <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=machfb&sektion=4&manpath=FreeBSD+6.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">machfb</span>(4)</span></a>, <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=ofw_console&sektion=4&manpath=FreeBSD+6.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">ofw_console</span>(4)</span></a>,
<a
href="http://www.FreeBSD.org/cgi/man.cgi?query=openfirm&sektion=4&manpath=FreeBSD+6.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">openfirm</span>(4)</span></a>, <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=openprom&sektion=4&manpath=FreeBSD+6.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">openprom</span>(4)</span></a>, <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=pmap_page_init&sektion=9&manpath=FreeBSD+6.0-RELEASE">
<span class="CITEREFENTRY"><span
class="REFENTRYTITLE">pmap_page_init</span>(9)</span></a>, <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=pthread_atfork&sektion=3&manpath=FreeBSD+6.0-RELEASE">
<span class="CITEREFENTRY"><span
class="REFENTRYTITLE">pthread_atfork</span>(3)</span></a>, <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=rtc&sektion=4&manpath=FreeBSD+6.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">rtc</span>(4)</span></a>, <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=sbus&sektion=4&manpath=FreeBSD+6.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">sbus</span>(4)</span></a>, <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=sched_4bsd&sektion=4&manpath=FreeBSD+6.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">sched_4bsd</span>(4)</span></a>,
<a
href="http://www.FreeBSD.org/cgi/man.cgi?query=sched_ule&sektion=4&manpath=FreeBSD+6.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">sched_ule</span>(4)</span></a>, <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=snd_fm801&sektion=4&manpath=FreeBSD+6.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">snd_fm801</span>(4)</span></a>, <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=snd_neomagic&sektion=4&manpath=FreeBSD+6.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">snd_neomagic</span>(4)</span></a>,
<a
href="http://www.FreeBSD.org/cgi/man.cgi?query=snd_t4dwave&sektion=4&manpath=FreeBSD+6.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">snd_t4dwave</span>(4)</span></a>,
<a
href="http://www.FreeBSD.org/cgi/man.cgi?query=snd_via8233&sektion=4&manpath=FreeBSD+6.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">snd_via8233</span>(4)</span></a>,
<a
href="http://www.FreeBSD.org/cgi/man.cgi?query=snd_via82c686&sektion=4&manpath=FreeBSD+6.0-RELEASE">
<span class="CITEREFENTRY"><span
class="REFENTRYTITLE">snd_via82c686</span>(4)</span></a>, and <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=snd_vibes&sektion=4&manpath=FreeBSD+6.0-RELEASE">
<span class="CITEREFENTRY"><span
class="REFENTRYTITLE">snd_vibes</span>(4)</span></a>.</p>

<p>Manual pages in the base system have received a number of cleanups, both for content
and presentation. Cross-references are more correct and consistent, standard section
headings are now used throughout, and markup has been cleaned up.</p>

<p>The following manual pages, which were derived from RFCs and possibly violate the
IETF's copyrights, have been replaced: <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=gai_strerror&sektion=3&manpath=FreeBSD+6.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">gai_strerror</span>(3)</span></a>,
<a
href="http://www.FreeBSD.org/cgi/man.cgi?query=getaddrinfo&sektion=3&manpath=FreeBSD+6.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">getaddrinfo</span>(3)</span></a>,
<a
href="http://www.FreeBSD.org/cgi/man.cgi?query=getnameinfo&sektion=3&manpath=FreeBSD+6.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">getnameinfo</span>(3)</span></a>,
<a
href="http://www.FreeBSD.org/cgi/man.cgi?query=inet6_opt_init&sektion=3&manpath=FreeBSD+6.0-RELEASE">
<span class="CITEREFENTRY"><span
class="REFENTRYTITLE">inet6_opt_init</span>(3)</span></a>, <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=inet6_option_space&sektion=3&manpath=FreeBSD+6.0-RELEASE">
<span class="CITEREFENTRY"><span
class="REFENTRYTITLE">inet6_option_space</span>(3)</span></a>, <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=inet6_rth_space&sektion=3&manpath=FreeBSD+6.0-RELEASE">
<span class="CITEREFENTRY"><span
class="REFENTRYTITLE">inet6_rth_space</span>(3)</span></a>, <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=inet6_rthdr_space&sektion=3&manpath=FreeBSD+6.0-RELEASE">
<span class="CITEREFENTRY"><span
class="REFENTRYTITLE">inet6_rthdr_space</span>(3)</span></a>, <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=icmp6&sektion=4&manpath=FreeBSD+6.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">icmp6</span>(4)</span></a>, and <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=ip6&sektion=4&manpath=FreeBSD+6.0-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">ip6</span>(4)</span></a>.
[MERGED]</p>
</div>
</div>

<div class="SECT1">
<hr />
<h2 class="SECT1"><a id="UPGRADE" name="UPGRADE">3 Upgrading from previous releases of
FreeBSD</a></h2>

<p>Source upgrades to FreeBSD 6.0-RELEASE are only supported from FreeBSD 5.3-RELEASE or
later. Users of older systems wanting to upgrade 6.0-RELEASE will need to update to
FreeBSD 5.3 or newer first, then to FreeBSD 6.0-RELEASE.</p>

<div class="IMPORTANT">
<blockquote class="IMPORTANT">
<p><b>Important:</b> Upgrading FreeBSD should, of course, only be attempted after backing
up <span class="emphasis"><i class="EMPHASIS">all</i></span> data and configuration
files.</p>
</blockquote>
</div>
</div>
</div>

<hr />
<p align="center"><small>This file, and other release-related documents, can be
downloaded from <a href="ftp://ftp.FreeBSD.org/">ftp://ftp.FreeBSD.org/</a>.</small></p>

<p align="center"><small>For questions about FreeBSD, read the <a
href="http://www.FreeBSD.org/docs.html">documentation</a> before contacting &#60;<a
href="mailto:questions@FreeBSD.org">questions@FreeBSD.org</a>&#62;.</small></p>

<p align="center"><small>For questions about this documentation, e-mail &#60;<a
href="mailto:doc@FreeBSD.org">doc@FreeBSD.org</a>&#62;.</small></p>
++++


